;NES Color Bars demo
;Assembles using Telemark Cross Assembler 3.2
;Use Left/Right to choose colors to display
;Use Up/Down to set color emphasis bits
;Press Select to toggle grayscale mode
;Press Start to hide the numbers
;Quietust, 2004/09/20

.org $0000
colors:		.block 8
curctrl:	.block 1
lastctrl:	.block 1
hitctrl:	.block 1
nmicount:	.block 1
altmode:	.block 1
newmode:	.block 1

.org $C000
sprites:
.db $78,$04,$20,$F8
.db $90,$0A,$00,$08
.db $90,$0B,$00,$10
.db $90,$0C,$00,$18
.db $18,$10,$00,$0C,$10,$10,$00,$0C
.db $18,$11,$00,$2C,$10,$10,$00,$2C
.db $18,$12,$00,$4C,$10,$10,$00,$4C
.db $18,$13,$00,$6C,$10,$10,$00,$6C
.db $18,$14,$00,$8C,$10,$10,$00,$8C
.db $18,$15,$00,$AC,$10,$10,$00,$AC
.db $18,$16,$00,$CC,$10,$10,$00,$CC
.db $18,$17,$00,$EC,$10,$10,$00,$EC

wr4_2007:
	STA $2007
wr3_2007:
	STA $2007
wr2_2007:
	STA $2007
	STA $2007
	RTS

reset:
	SEI
	CLD
	LDX #$00
	STX $2000
	STX $2001
	INX
waitvb:	LDA $2002
	BPL waitvb
	DEX
	BPL waitvb
	TXS

	LDA #$20
	STA $2006
	LDA #$00
	STA $2006
	LDX #$1E
initnt:	LDA #$01
	JSR wr4_2007
	LDA #$02
	JSR wr4_2007
	LDA #$03
	JSR wr4_2007
	LDA #$01
	JSR wr4_2007
	LDA #$02
	JSR wr4_2007
	LDA #$03
	JSR wr4_2007
	LDA #$01
	JSR wr4_2007
	LDA #$02
	JSR wr4_2007
	DEX
	BNE initnt
	LDX #$08
initat:	LDA #$00
	JSR wr3_2007
	LDA #$55
	JSR wr3_2007
	LDA #$AA
	JSR wr2_2007
	DEX
	BNE initat

	LDA #$F8
clrspr:	STA $0200,X
	INX
	INX
	INX
	INX
	BNE clrspr

	LDY #$50
initsp:	LDA sprites,X
	STA $0200,X
	INX
	DEY
	BNE initsp

	LDA #$3F
	STA $2006
	LDA #$00
	STA $2006
	LDX #$20
	LDA #$0F
clrpal:	STA $2007
	DEX
	BNE clrpal

	LDX #$3F
	STX $2006
	LDX #$11
	STX $2006
	LDA #$10
	STA $2007
	LDA #$0F
	STA $2007
	LDA #$20
	STA $2007

	LDA #$00
	STA $4015
	LDA #$40
	STA $4017

	LDX #$00
	LDY #$08
intcol:	TXA
	STA colors,X
	INX
	DEY
	BNE intcol

	LDA #$00
	STA nmicount
	STA altmode	

	LDA #$80
	STA $2000

loop:	LDA nmicount
	BEQ loop
	DEC nmicount

	LDA hitctrl
	ASL A		;right
	BCC noright

	PHA
	LDX #$00
	LDY #$08
inccol:	LDA colors,X
	CLC
	ADC #$01
	AND #$3F
	STA colors,X
	INX
	DEY
	BNE inccol
	PLA

noright:
	ASL A		;left
	BCC noleft

	PHA
	LDX #$00
	LDY #$08
deccol:	LDA colors,X
	SEC
	SBC #$01
	AND #$3F
	STA colors,X
	INX
	DEY
	BNE deccol
	PLA

noleft:	ASL A		;down
	BCC nodown

	PHA
	LDA altmode
	SEC
	SBC #$20
	STA altmode
	PLA

nodown:	ASL A		;up
	BCC noup

	PHA
	LDA altmode
	CLC
	ADC #$20
	STA altmode
	PLA

noup:	ASL A		;start
	BCC nostart
	PHA

	LDX #$00
	LDY #$13
hide:	LDA $0206,X
	EOR #$20
	STA $0206,X
	INX
	INX
	INX
	INX
	DEY
	BNE hide

	PLA
nostart:
	ASL A		;select
	BCC noselect
	PHA
	LDA altmode
	EOR #$01
	STA altmode
	PLA
noselect:

	LDX #$00
	LDY #$00
setspr:	LDA colors,X
	PHA
	AND #$0F
	ORA #$10
	STA $0211,Y
	INY
	INY
	INY
	INY
	PLA
	LSR A
	LSR A
	LSR A
	LSR A
	ORA #$10
	STA $0211,Y
	INY
	INY
	INY
	INY
	INX
	CPX #8
	BNE setspr

	LDA altmode
	LDX #$0A
	AND #$20
	BEQ nored
	LDX #$0D
nored:	STX $0205
	LDA altmode
	LDX #$0B
	AND #$40
	BEQ nogrn
	LDX #$0E
nogrn:	STX $0209
	LDA altmode
	LDX #$0C
	AND #$80
	BEQ noblu
	LDX #$0F
noblu:	STX $020D

sp0no:	BIT $2002
	BVS sp0no
sp0yes:	BIT $2002
	BVC sp0yes

	LDA newmode
	ORA #$1E
	STA $2001
	LDA altmode
	STA newmode
	JMP loop

nmi:	PHA
	TXA
	PHA
	TYA
	PHA
	LDA #$00
	STA $2003
	LDA #$02
	STA $4014

	LDA #$3F
	STA $2006
	LDA #$00
	STA $2006
	LDX #$00
	LDY #$03
setpal:	LDA #$0F
	STA $2007
	LDA colors,X
	STA $2007
	INX
	LDA colors,X
	STA $2007
	INX
	LDA colors,X
	STA $2007
	INX
	DEY
	BNE setpal

	LDA #$3F
	STA $2006
	LDA #$00
	STA $2006
	STA $2006
	STA $2006

	LDX #$09
	STX $4016
	DEX
	STX $4016
readc:	LDA $4016
	LSR A
	ROR curctrl
	DEX
	BNE readc
	LDA curctrl
	PHA
	EOR lastctrl
	AND curctrl
	STA hitctrl
	PLA
	STA lastctrl

	LDA #$1E
	STA $2001
	LDA #$80
	STA $2000
	LDA #$00
	STA $2005
	STA $2005
	INC nmicount
	PLA
	TAY
	PLA
	TAX
	PLA
irq:	RTI

.fill $FFFA-*,$00
.dw nmi,reset,irq
.end
